Package com.io7m.waxmill.machines

# Class WXMDeviceVirtioBlockStorage

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceVirtioBlockStorage

All Implemented Interfaces:
  `WXMDeviceType`, `WXMDeviceType.WXMDeviceVirtioBlockStorageType`

    public final class WXMDeviceVirtioBlockStorage
    extends java.lang.Object
    implements WXMDeviceType.WXMDeviceVirtioBlockStorageType

Immutable implementation of `WXMDeviceType.WXMDeviceVirtioBlockStorageType`.

Use the builder to create immutable instances: `WXMDeviceVirtioBlockStorage.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMDeviceVirtioBlockStorage.Builder` | Builds instances of type `WXMDeviceVirtioBlockStorage`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `WXMDeviceType.Kind, WXMDeviceType.WXMDeviceAHCIDiskType, WXMDeviceType.WXMDeviceAHCIOpticalDiskType, WXMDeviceType.WXMDeviceE1000Type, WXMDeviceType.WXMDeviceFramebufferType, WXMDeviceType.WXMDeviceHostBridgeType, WXMDeviceType.WXMDeviceLPCType, WXMDeviceType.WXMDevicePassthruType, WXMDeviceType.WXMDeviceVirtioBlockStorageType, WXMDeviceType.WXMDeviceVirtioNetworkType, WXMDeviceType.WXMLPCTTYNames, WXMDeviceType.WXMSectorSizesType, WXMDeviceType.WXMStorageBackendFileType, WXMDeviceType.WXMStorageBackendType, WXMDeviceType.WXMStorageBackendZFSVolumeType, WXMDeviceType.WXMTTYBackendFileType, WXMDeviceType.WXMTTYBackendNMDMType, WXMDeviceType.WXMTTYBackendStdioType, WXMDeviceType.WXMTTYBackendType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMDeviceType.WXMStorageBackendType` | `backend()` |
  `static WXMDeviceVirtioBlockStorage.Builder` | `builder()` | Creates a builder for `WXMDeviceVirtioBlockStorage`.
  `java.lang.String` | `comment()` |
  `static WXMDeviceVirtioBlockStorage` | `copyOf​(WXMDeviceType.WXMDeviceVirtioBlockStorageType instance)` | Creates an immutable copy of a `WXMDeviceType.WXMDeviceVirtioBlockStorageType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMDeviceVirtioBlockStorage` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `deviceSlot`, `comment`, `backend`.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMDeviceVirtioBlockStorage` with attribute values.
  `WXMDeviceVirtioBlockStorage` | `withBackend​(WXMDeviceType.WXMStorageBackendType value)` | Copy the current immutable object by setting a value for the `backend` attribute.
  `WXMDeviceVirtioBlockStorage` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMDeviceVirtioBlockStorage` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `isConsoleDevice, isStorageDevice`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceVirtioBlockStorageType

  `externalName, kind`

- ## Method Details

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXMDeviceType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceVirtioBlockStorageType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMDeviceType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceVirtioBlockStorageType`
    Returns:
      The value of the `comment` attribute

  - ### backend

    public WXMDeviceType.WXMStorageBackendType backend()
    Specified by:
      `backend` in interface `WXMDeviceType.WXMDeviceVirtioBlockStorageType`
    Returns:
      The value of the `backend` attribute

  - ### withDeviceSlot

    public final WXMDeviceVirtioBlockStorage withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withComment

    public final WXMDeviceVirtioBlockStorage withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withBackend

    public final WXMDeviceVirtioBlockStorage withBackend​(WXMDeviceType.WXMStorageBackendType value)
    Copy the current immutable object by setting a value for the `backend` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for backend
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMDeviceVirtioBlockStorage` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `deviceSlot`, `comment`, `backend`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMDeviceVirtioBlockStorage` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMDeviceVirtioBlockStorage copyOf​(WXMDeviceType.WXMDeviceVirtioBlockStorageType instance)
    Creates an immutable copy of a `WXMDeviceType.WXMDeviceVirtioBlockStorageType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMDeviceVirtioBlockStorage instance

  - ### builder

    public static WXMDeviceVirtioBlockStorage.Builder builder()
    Creates a builder for `WXMDeviceVirtioBlockStorage`.

         WXMDeviceVirtioBlockStorage.builder()
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setComment(String) // optional comment
            .setBackend(com.io7m.waxmill.machines.WXMDeviceType.WXMStorageBackendType) // required backend
            .build();

    Returns:
      A new WXMDeviceVirtioBlockStorage builder